-------------------------------------------
--- AddOn: ReadySetDing					---
--- Author: Ketho (EU-Boulderfist)		---
--- Created: 2010.01.10					---
--- License: Public Domain				---
-------------------------------------------
--- ReadySetDing	v0.83 [2011.03.14]	---
--- Ace3 Framework	r1025 [2011.04.27]	---
-------------------------------------------
--- Curse			http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
--- WoWInterface	http://www.wowinterface.com/downloads/info16220-ReadySetDing.html
--- I don't have any previous programming experience or background in any (scripting) language

ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0")
local RSD = ReadySetDing
local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("ReadySetDing", true)

	--------------------
	--- 01  UPVALUES ---
	--------------------

local _G = _G
--# Lua APIs
local print = print
local pairs, select, type = pairs, select, type
local tonumber, unpack = tonumber, unpack
local floor, mod, random = floor, mod, random
local date, time = date, time
local strtrim = strtrim
local format, gsub = format, gsub
local tmaxn = table.maxn

--# WoW APIs
local SCM, GS, PSF = SendChatMessage, GetStatistic, PlaySoundFile
local GuildRoster, GetGuildRosterInfo = GuildRoster, GetGuildRosterInfo
local FriendsFrame_Update, GetFriendInfo = FriendsFrame_Update, GetFriendInfo
local IsInGuild = IsInGuild

-- modified globalstrings
local ADVANCED = gsub(ADVANCED_LABEL, "|T.-|t", "")

-- table reference shortcuts
local profile, realm, char
local stats

-- other
local playerDinged
local levelTime
local TPM_totalTime, TPM_currentTime = 0, 0
local TPM_totalTime2, TPM_currentTime2
local lastPlayedRequest, timeLogin = time(), time()
local timeAFK1, timeAFK2
local randomIcon1, randomIcon2
local soundPath, showedDiffs

-- don't want the capitalized GlobalStrings (except for German)
local D_SECONDS = strlower(D_SECONDS)
local D_MINUTES = strlower(D_MINUTES)
local D_HOURS = strlower(D_HOURS)
local D_DAYS = strlower(D_DAYS)

if GetLocale() == "deDE" then
	D_SECONDS = _G.D_SECONDS
	D_MINUTES = _G.D_MINUTES
	D_HOURS = _G.D_HOURS
	D_DAYS = _G.D_DAYS
end

local bttn = CreateFrame("Button")
local D_MINUTES2 = gsub(D_MINUTES, "%%d", "%%.1f") -- replace decimal integer with float
local HOUR = strreplace(bttn:GetText(bttn:SetFormattedText(_G.D_HOURS, 1)), "1 ", "") -- singular hour
local MINUTES = strreplace(bttn:GetText(bttn:SetFormattedText(_G.D_MINUTES, 2)), "2 ", "") -- plural minutes

local iconCropped = ":64:64:4:60:4:60"
local RT = "Interface\\TargetingFrame\\UI-RaidTargetingIcon_"

-- these strings are too damned long
-- imma cutting them in pieces. rawr.
local legend, legend2, legend3
do
	local x1 = "\n|cff58ACFA[QUESTS]|r |cffFFFFFF= "..QUESTS_LABEL.."|r\n|cff58ACFA[ZONE]|r |cffFFFFFF= "..strupper(strsub(SPELL_TARGET_TYPE6_DESC, 1, 1))..strsub(SPELL_TARGET_TYPE6_DESC, 2).."|r\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffF6ADC6[LEVEL]|r |cffFFFFFF= "..L["New Level"].."|r\n|cffF6ADC6[REM]|r |cffFFFFFF= "..L["Remaining Levels"].."|r"
	local x2 = "\n|cffF6ADC6[MAX]|r |cffFFFFFF= "..L["Max Level"].."|r\n|cff71D5FF[TIME]|r |cffFFFFFF= "..L["Level Time"].."|r\n|cff71D5FF[TOTAL]|r |cffFFFFFF= "..L["Total Time"].."|r\n|cff71D5FF[DIFF]|r |cffFFFFFF= "..L["Difference"].."|r\n|cff71D5FF[AFK]|r, |cff71D5FF[AFK+]|r |cffFFFFFF= "..L["AFK Time"].."|r"
	local x3 = "\n|cffB6CA00[XP]|r |cffFFFFFF= "..COMBAT_XP_GAIN.." "..SPEED.."|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["Level Speed"].."|r\n|cffB6CA00[SPEED+]|r |cffFFFFFF= "..L["Average"].." "..L["Level Speed"].."|r\n|cff0070DD[DATE]|r  |cffFFFFFF= MM/DD/YY hh:mm|r\n|cff0070DD[DATE2]|r |cffFFFFFF= YYYY.MM.DD hh:mm|r"
	local x4 = "\n|cffFF0000[KILLS]|r, |cffFF0000[KILLS+]|r |cffFFFFFF= "..KILLS.."|r\n|cffFF0000[DEATHS]|r, |cffFF0000[DEATHS+]|r |cffFFFFFF= "..DEATHS.."|r\n|cffADFF2F[NAME]|r, |cffADFF2F[CLASS]|r, |cffADFF2F[RACE]|r, |cffADFF2F[GUILD]|r, |cffADFF2F[FACTION]|r, |cffADFF2F[REALM]|r\n"..TARGETICONS..": |cffFFFFFF{Moon} |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:12|t|r"
	
	local y1 = "\n|cff71D5FF[NAME]|r |cffFFFFFF= "..NAME.."|r\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffADFF2F[LEVEL] |cffFFFFFF= "..L["New Level"].."|r\n|cff71D5FF[CLASS]|r"
	local y2 = "|cffFFFFFF= "..CLASS.."|r\n|cffADFF2F[RANK]|r |cffFFFFFF= "..RANK.."|r\n|cffF6ADC6[ZONE]|r |cffFFFFFF= "..ZONE.."|r\n|cff71D5FF[TIME]|r |cffFFFFFF=|r |cffF6ADC6RealTime|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["Level Speed"].."|r"

	legend = x1..x2..x3..x4
	legend2 = y1..y2
end

local optionsFrame = {}

-- internal cooldowns array
local cd = {}

local player = {
	realm = GetRealmName(),
	faction = select(2, UnitFactionGroup("player")),
	class = UnitClass("player"),
	race = UnitRace("player"),
	level = UnitLevel("player"),
	name = UnitName("player"),
	XPMax = UnitXPMax("player"),
	maxLevel = 85,
}

	------------------------------
	--- 02  Options & Defaults ---
	------------------------------

local defaults = {
	profile = {
		GuildMemberDings = true,
		partyAnnounce = true,
		dingMessage = {
			L["dingMessage1"],
			L["dingMessage2"],
			L["dingMessage3"],
			L["dingMessage4"],                
			L["dingMessage5"],
			L["dingMessage6"],
		},
		outputFrame = 2,
		Language = 1,
		timeFormat = 2,
		announceDelay = 0,
		guildMemberAchievementFilter = true,
		guildMemberLevelFilter = 10,
		guildMemberMsg = {
			L["guildMemberMsg1"],
			L["guildMemberMsg2"],
			L["guildMemberMsg3"],
			L["guildMemberMsg4"],
			L["guildMemberMsg5"],
			L["guildMemberMsg6"],
		},
		screenshotDelay = 1,
		customSound = "Interface\\AddOns\\ReadySetDing\\Sounds\\MySound.mp3",
		autoGratzDelay = 0,
		autoGratzCooldown = 60,
		autoGratzMsg = {
			L["gratzMsg1"],
			L["gratzMsg2"],
			L["gratzMsg3"],
			L["gratzMsg4"],
			L["gratzMsg5"],
			L["gratzMsg6"],
		},
	},
	char = {
		-- just needed a starting value
		-- and don't know how to do it the proper way :s
		stats = {
			timeAFK = 0,
			totalAFK = 0,
			kills = 0,
			deaths = 0,
		},
	},
}

local options = {
	type = "group",
	name = "",
	args = {
		Main = {
			type = "group",
			name = "\124cffADFF2FReadySet\124r|cffFFFFFFDing|r |cffB6CA00v0.83|r |cff4169E1Beta|r",
			handler = RSD,
			args = {
				header1 = {type = "header", order = 1, name = "|cffFFFFFF"..SHOW.."|r Dings"},
				ShowParty = {
					type = "toggle",
					order = 2,
					descStyle = "",
					name = " |cffA8A8FF"..PARTY.."|r",
					get = function(i) return profile.partyDings end,
					set = function(i, v) profile.partyDings = v end,
					disabled = "OptionsDisabled",
				},
				showFriend = {
					type = "toggle",
					order = 3,
					descStyle = "",
					name = " "..FRIENDS,
					get = function(i) return profile.friendDings end,
					set = function(i, v) profile.friendDings = v end,
					disabled = "OptionsDisabled",
				},
				showGuildMember = {
					type = "toggle",
					order = 4,
					descStyle = "",
					name = " |cff40FF40"..GUILD.."|r",
					get = function(i) return profile.GuildMemberDings end,
					set = function(i, v) profile.GuildMemberDings = v end,
					disabled = "OptionsDisabled",
				},
				showRealIDFriend = {
					type = "toggle",
					order = 5,
					descStyle = "",
					name = " |cff82C5FF"..BATTLENET_FRIEND.."|r "..FRIENDS,
					get = function(i) return profile.RealID_Dings end,
					set = function(i, v) profile.RealID_Dings = v end,
					disabled = "OptionsDisabled",
				},
				header2 = {type = "header", order = 6, name = "|cffFFFFFF"..CHAT_ANNOUNCE.."|r Dings"},
				announceParty = {
					type = "toggle",
					order = 7,
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:3:0:32:32:2:30:2:30|t   |cffA8A8FF"..CHAT_MSG_PARTY.."|r",
					get = function(i) return profile.partyAnnounce end,
					set = function(i, v) profile.partyAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				announceZone = {
					type = "toggle",
					order = 8,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Map_01:20:20:1:0"..iconCropped.."|t   "..ZONE,
					get = function(i) return profile.zoneAnnounce end,
					set = function(i, v) profile.zoneAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				announceGuild = {
					type = "toggle",
					order = 9,
					descStyle = "",
					name = function() return RSD:GuildEmblem().."|cff40FF40"..CHAT_MSG_GUILD.."|r" end,
					get = function(i) return profile.guildAnnounce end,
					set = function(i, v) profile.guildAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				broadcastBNet = {
					type = "toggle",
					order = 10,
					desc = BN_BROADCAST_TOOLTIP,
					name = function()
						if time() > (cd.randomIcon1 or 0) then
							cd.randomIcon1 = time() + 120
							local a = random(4)
							if	   a <= 2 then randomIcon1 = "PlusManz-BattleNet" -- \Data\enGB\locale-enGB.MPQ\Interface\FriendsFrame\PlusManz-BattleNet.blp
							elseif a == 3 then randomIcon1 = "Battlenet-WoWicon"
							elseif a == 4 then randomIcon1 = "Battlenet-Sc2icon"
							end
						end
						return "|TInterface\\FriendsFrame\\"..randomIcon1..":24|t  |cff82C5FF"..BATTLENET_FRIEND.."|r"
					end,
					get = function(i) return profile.BNetBroadcast end,
					set = function(i, v) profile.BNetBroadcast = v end,
					disabled = "OptionsDisabled",
				},
				inputDingMessage = {
					type = "input",
					order = 11,
					width = "full",
					name = " ", -- If it was like "" then usage wouldnt appear
					usage = legend,
					get = function(i) return profile.dingMessage[1] end,
					set = function(i, v) profile.dingMessage[1] = v
						RSD:ValidateMessage(v)
						if #strtrim(v) == 0 then profile.dingMessage[1] = defaults.profile.dingMessage[1] end
					end,
					disabled = function() return not RSD:IsEnabled() or profile.randomMessage end,
				},
				descriptionExample = {
					type = "description",
					order = 12,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[1], "ExampleDingMsg") end,
				},
				spacing = {type = "description", order = 13, name = ""},
				descriptionLevelSummary = {
					type = "description",
					order = 14,
					name = function() return RSD:LevelSummary() end,
				},
			},
		},
		Advanced = {
			type = "group",
			name = "",
			handler = RSD,
			args = {
				selectOutputFrame = {
					type = "select",
					order = 1,
					descStyle = "",
					name = "   |cffFFFFFFOutput Frame|r",
					values = function()
						local a, ChatWindows = "|cff2E9AFE", {}
						ChatWindows[1] = a.."#|r  UIErrorsFrame"
						ChatWindows[2] = a.."#|r  RaidWarningFrame"
						ChatWindows[3] = a.."#|r  RaidBossEmoteFrame"
						for i = 1, NUM_CHAT_WINDOWS do
							local b = GetChatWindowInfo(i)
							if #b > 0 then
								ChatWindows[i+3] = a..i..".|r "..b
							end
						end
						return ChatWindows
					end,
					get = function(i) return profile.outputFrame end,
					set = function(i, v) profile.outputFrame = v
						RSD:OutputFrame(nil, true)
					end,
					disabled = "OptionsDisabled",
				},
				newline1 = {type = "description", order = 2, name = ""},
				selectLanguage = {
					type = "select",
					order = 3,
					descStyle = "",
					name = "   |cffFFFFFF"..LANGUAGES_LABEL.."|r",
					values = function()
						local a, languages = "|cff2E9AFE", {}
						languages[1] = a.."#|r  |cffFBDB00"..DEFAULT.."|r"
						languages[2] = a.."#|r  |cff71D5FFRandom|r"
						for i = 1, GetNumLanguages() do
							languages[i+2] = a..i..".|r "..GetLanguageByIndex(i)
						end
						return languages
					end,
					get = function(i) return profile.Language end,
					set = function(i, v) profile.Language = v end,
					disabled = "OptionsDisabled",
				},
				newline2 = {type = "description", order = 4, name = ""},
				selectTimeFormat = {
					type = "select",
					order = 5,
					descStyle = "",
					name = "   |cffFFFFFFTime Format|r (|cff71D5FF"..MINUTES.."|r)",
					values = {"|cffB6CA00X|r minutes, |cffF6ADC6Y|r seconds", "|cffB6CA00X|r.|cffF6ADC6Y|r minutes"},
					get = function(i) return profile.timeFormat end,
					set = function(i, v) profile.timeFormat = v end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 6, name = ""},
				toggleDingEmote = {
					type = "toggle",
					order = 7,
					width = "full",
					desc = "\""..TUTORIAL_TITLE55.."\"",
					name = "|TInterface\\Icons\\Achievement_PVP_H_14:20:20|t |cffFFFFFF"..EMOTE389_CMD1.."|r |cffFFFF00"..EMOTE.."|r",
					get = function(i) return profile.dingEmote end,
					set = function(i, v) profile.dingEmote = v end,
					disabled = "OptionsDisabled",
				},
				toggleRandomMessage = {
					type = "toggle",
					order = 8,
					width = "full",
					descStyle = "",
					name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:20:20:0:1|t |cffF6ADC6Random|r Messages",
					get = function(i) return profile.randomMessage end,
					set = function(i, v) profile.randomMessage = v
						if v then
							ACD:Open("ReadySetDing_RandomMessage")
						end
					end,
					disabled = "OptionsDisabled",
				},
				spacing = {type = "description", order = 9, name = ""},
				rangeAnnounceDelay = {
					type = "range",
					order = 10,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 0 "..strlower(SECONDS),
					name = "  |cffFFFFFF"..CHAT_ANNOUNCE.."|r "..L["Delay"],
					get = function(i) return profile.announceDelay end,
					set = function(i, v) profile.announceDelay = v end,
					min = 0, softMin = 0,
					max = 60, softMax = 10,
					step = 0.5,
					disabled = "OptionsDisabled",
				},
				-- yes i'm a micro$oft fanboi .. Windows 7 FTW! .. Tux must die
				win7 = {type = "description", order = 11, name = "|TInterface\\AddOns\\ReadySetDing\\Images\\ReadySet7:32:128:5:-100|t"},
			},
		},
		GuildMemberDings = {
			type = "group",
			name = "|cff40FF40"..GUILD.." Member|r Dings",
			handler = RSD,
			args = {
				toggleGuildMemberAnnounce = {
					type = "toggle",
					order = 1,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:1:0"..iconCropped.."|t  "..CHAT_ANNOUNCE.." |cff40FF40"..GUILD.." Member|r Dings ",
					get = function(i) return profile.guildMemberAnnounce end,
					set = function(i, v) profile.guildMemberAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				toggleGuildMemberAchievementFiter = {
					type = "toggle",
					order = 2,
					width = "full",
					desc = LEVEL.." |cffB6CA0010|r, |cffB6CA0020|r, |cffB6CA0030|r, ...|r",
					name = function()
						if time() > (cd.randomIcon2 or 0) then
							cd.randomIcon2 = time() + 60
							randomIcon2 = math.random(9)*10
							if randomIcon2 == 90 then randomIcon2 = 85 end
						end
						return "|TInterface\\Icons\\Achievement_Level_"..randomIcon2..":20:20:1:0"..iconCropped.."|t  |cffFFFF00"..ACHIEVEMENTS.."|r "..FILTER
					end,
					get = function(i) return profile.guildMemberAchievementFilter end,
					set = function(i, v) profile.guildMemberAchievementFilter = v end,
					disabled = "OptionsDisabled",
				},
				toggleRandomMessageGuild = {
					type = "toggle",
					order = 3,
					width = "full",
					descStyle = "",
					name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:-2:1|t |cffF6ADC6Random|r |cff40FF40"..CHAT_MSG_GUILD.."|r Messages",
					get = function(i) return profile.randomMessageGuild end,
					set = function(i, v) profile.randomMessageGuild = v
						if v then
							ACD:Open("ReadySetDing_RandomMessageGuild")
						end
					end,
					disabled = "OptionsDisabled",
				},
				spacing = {type = "description", order = 4, name = ""},
				rangeGuildMemberFilter = {
					type = "range",
					order = 5,
					desc = "|cffF6ADC6"..DEFAULT.."|r = "..LEVEL.." 10",
					name = "  |cffFFFFFF"..LEVEL.."|r "..FILTER,
					get = function(i) return profile.guildMemberLevelFilter end,
					set = function(i, v) profile.guildMemberLevelFilter = v end,
					min = 2,
					max = 85,
					step = 1,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 6, name = ""},
				inputGuildMemberMsg = {
					type = "input",
					order = 7,
					width = "full",
					name = " ",
					usage = legend2,
					get = function(i) return profile.guildMemberMsg[1] end,
					set = function(i, v) profile.guildMemberMsg[1] = v
						if #strtrim(v) == 0 then profile.guildMemberMsg[1] = defaults.profile.guildMemberMsg[1] end
					end,
					disabled = function() return not RSD:IsEnabled() or profile.randomMessageGuild end,
				},
				descriptionExample = {
					type = "description",
					order = 8,
					name = function() return RSD:GetGuildExampleMsg(1) end,
				},
				description2 = {
					type = "description",
					order = 9,
					name = "\n\n\n\n\n\n\n\n\n |cff71D5FF[TIME]|r = |cffF6ADC6Real world time|r (!)\n\n |cffFF0000Note:|r Level Speed Ranking is |cffF6ADC6experimental|r\n",
				},
				GuildMemberLevelSpeed = {
					type = "execute",
					order = 10,
					name = "|TInterface\\Icons\\INV_Misc_Note_01:16:16:1:-1"..iconCropped.."|t |cffFFFFFF"..L["Level Speed"].."|r",
					func = function()
						local list = {}
						for i = 1, GetNumGuildMembers() do
							local name = GetGuildRosterInfo(i)
							if realm[name] and realm[name][0] then
								list[realm[name][0]] = name
							end
						end
						local i, t = 1, {}
						for k, v in pairs(list) do
							t[i] = k
							i = i + 1
						end
						sort(t)
						for i = 1, #t do
							print("#"..i.." |cff71D5FF"..list[t[i]].."|r |cffADFF2F"..format("%.2f", t[i]).."|r "..HOUR.."/"..LEVEL.." (|cffB6CA00"..realm[list[t[i]]][1].."|r)")
						end
					end,
					disabled = "OptionsDisabled",
				},
			},
		},
		Screenshot = {
			type = "group",
			name = "|cffFFFFFFDing|r "..L["Screenshot"],
			handler = RSD,
			args = {
				toggleScreenshot = {
					type = "toggle",
					order = 1,
					desc = BINDING_NAME_SCREENSHOT,
					name = "|TInterface\\Icons\\inv_misc_spyglass_03:20:20:1:0"..iconCropped.."|t  Ding |cffFBDB00"..L["Screenshot"].."|r",
					get = function() return profile.Screenshot end,
					set = function(i, v) profile.Screenshot = v end,
					disabled = "OptionsDisabled",
				},
				toggleScreenshotHideUI = {
					type = "toggle",
					order = 2,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Gizmo_GoblingTonkController:20:20:1:1:64:64:4:60:4:60|t  "..HIDE.." "..BUG_CATEGORY5,
					get = function(i) return profile.screenshotHideUI end,
					set = function(i, v) profile.screenshotHideUI = v end,
					disabled = function() return not RSD:IsEnabled() or not profile.Screenshot end,
				},
				spacing = {type = "description", order = 3, name = " "},
				rangeScreenshotDelay = {
					type = "range",
					order = 4,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 1 "..strlower(SECONDS),
					name = "  |cffFFFFFF"..L["Screenshot"].."|r "..L["Delay"],
					get = function(i) return profile.screenshotDelay end,
					set = function(i, v) profile.screenshotDelay = v end,
					min = 0, softMin = 0,
					max = 60, softMax = 2,
					step = 0.1,
					disabled = "OptionsDisabled",
				},
			},
		},
		Sound = {
			type = "group",
			name = " |TInterface\\Icons\\INV_Misc_Bell_01:16:16:0:3"..iconCropped.."|t  |cffFFFFFFDing|r Sound",
			handler = RSD,
			args = {
				inputCustomSound = {
					type = "input",
					order = 1,
					width = "full",
					multiline  = true,
					desc = "WoW sound files are also possible\n\n|cffFF0000Note:|r Restart is required for loading the sound file",
					name = " ",
					get = function(i) return profile.customSound end,
					set = function(i, v) profile.customSound = v
						if #strtrim(v) == 0 then profile.customSound = defaults.profile.customSound end
					end,
					disabled = "OptionsDisabled",
				},
				executeTestSound = {
					type = "execute",
					order = 2,
					width = "half",
					name = "Test",
					func = function()
						--	would be kinda annoying if some1 accidentally spammed this in combination with long sound files
						if time() > (cd.customSound or 0) then
							cd.customSound = time() + 2
							PlaySoundFile(profile.customSound, "Master")
						end
					end,
					disabled = "OptionsDisabled",
				},
			},
		},
		AutoGratz = {
			type = "group",
			name = "|cffFFFFFF"..L["Auto Gratz"].."|r",
			handler = RSD,
			args = {
				toggleAutoGratz = {
					type = "toggle",
					order = 1,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Gift_05:20:20:1:0"..iconCropped.."|t  "..L["Auto Gratz"],
					get = function(i) return profile.AutoGratz end,
					set = function(i, v) profile.AutoGratz = v end,
					disabled = "OptionsDisabled",
				},
				toggleGratzAllAchievements = {
					type = "toggle",
					order = 2,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Achievement_Reputation_06:20:20:1:1"..iconCropped.."|t  Triggers on all |cffFFFF00"..ACHIEVEMENTS.."|r",
					get = function(i) return profile.gratzAllAchievements end,
					set = function(i, v) profile.gratzAllAchievements = v end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 3, name = ""},
				rangeAutoGratzDelay = {
					type = "range",
					order = 4,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 0 "..strlower(SECONDS).." (|cffFF8000Random|r)",
					name = L["Delay"],
					get = function(i) return profile.autoGratzDelay end,
					set = function(i, v) profile.autoGratzDelay = v end,
					min = 0, softMin = 0,
					max = 60, softMax = 10,
					step = 0.5,
					disabled = "OptionsDisabled",
				},
				rangeAutoGratzCooldown = {
					type = "range",
					order = 5,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 60 "..strlower(SECONDS),
					name = L["Cooldown"],
					get = function(i) return profile.autoGratzCooldown end,
					set = function(i, v) profile.autoGratzCooldown = v end,
					min = 0, softMin = 0,
					max = 600, softMax = 120,
					step = 1,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 6, name = ""},
				inputAutoGratzMsg1 = {
					type = "input",
					order = 7,
					name = "",
					get = function(i) return profile.autoGratzMsg[1] end,
					set = function(i, v) profile.autoGratzMsg[1] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[1] = defaults.profile.autoGratzMsg[1] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg2 = {
					type = "input",
					order = 8,
					name = "",
					get = function(i) return profile.autoGratzMsg[2] end,
					set = function(i, v) profile.autoGratzMsg[2] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[2] = defaults.profile.autoGratzMsg[2] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg3 = {
					type = "input",
					order = 9,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[3] end,
					set = function(i, v) profile.autoGratzMsg[3] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[3] = defaults.profile.autoGratzMsg[3] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg4 = {
					type = "input",
					order = 10,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[4] end,
					set = function(i, v) profile.autoGratzMsg[4] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[4] = defaults.profile.autoGratzMsg[4] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg5 = {
					type = "input",
					order = 11,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[5] end,
					set = function(i, v) profile.autoGratzMsg[5] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[5] = defaults.profile.autoGratzMsg[5] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg6 = {
					type = "input",
					order = 12,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[6] end,
					set = function(i, v) profile.autoGratzMsg[6] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[6] = defaults.profile.autoGratzMsg[6] end end,
					disabled = "OptionsDisabled",
				},
				descriptionRaidTarget = {
					type = "description",
					order = 13,
					fontSize = "medium",
					name = function()
						local t = {}
						for i = 1, 8 do
							t[i] = "  |T"..RT..i..":16:16:0:4|t {rt"..i.."}"
						end
						return strjoin("\n", unpack(t))
					end,
				},
			},
		},
		Stats = {
			type = "group",
			name = "",
			handler = RSD,
			args = {
				Experience = {
					type = "description",
					order = 1,
					name = function() return " "..COMBAT_XP_GAIN.." = |cffB6CA00"..UnitXP("player").."|r / |cff71D5FF"..UnitXPMax("player").."|r = |cffADFF2F"..floor((UnitXP("player")/UnitXPMax("player"))*100).."%|r" end,
				},
				LevelDate = {
					type = "description",
					order = 2,
					name = function()
						-- using table.maxn, since here it will include the corresponding level next to it
						-- and then it's affordable to rather show the outdated/previous level data, instead of "[No Data]"
						local a = tmaxn(char.dateStampList)
						local b = char.dateStampList[a]
						local c = a > 0 and " "..LEVEL.." |cffB6CA00"..a.."|r: " or " "..LEVEL..": "
						return b and c.."|cff71D5FF"..b.."|r\n" or c.."|cffF6ADC6"..L["[No Data]"].."|r\n"
					end,
				},
				RealTime = {
					type = "description",
					order = 3,
					name = function()
						local a = char.unixTimeList[player.level]
						local b = " "..L["Real Time"].." = "
						return a and b.."|cffB6CA00"..RSD:TimetoString(time()-a).."|r" or b.."|cffF6ADC6"..L["[No Data]"].."|r"
					end,
				},
				LevelTime = {
					type = "description",
					order = 4,
					name = function() return " "..L["Level Time"].." = |cffADFF2F"..RSD:TimetoString(TPM_currentTime+RSD:AddedTime()).."|r" end,
				},
				TotalTime = {
					type = "description",
					order = 5,
					name = function() return " "..L["Total Time"].." = |cff71D5FF"..RSD:TimetoString(TPM_totalTime+RSD:AddedTime()).."|r" end,
				},
				LevelDiff = {
					type = "description",
					order = 6,
					name = function()
						local a = " "..L["Difference"].." = "
						return RSD:TimeDiff(true) == L["[No Data]"] and a.."|cffF6ADC6"..L["[No Data]"].."|r\n" or a.."|cff6495ED"..RSD:TimeDiff(true).."|r\n"
					end,
				},
				XP_Speed = {
					type = "description",
					order = 7,
					name = function() return " "..XP.." "..SPEED.." = |cffADFF2F"..format("%0.f", UnitXP("player")/((TPM_currentTime+RSD:AddedTime())/3600)).."|r "..XP.."/"..HOUR end,
				},
				LevelSpeed = {
					type = "description",
					order = 8,
					name = function()
						local a = " "..L["Level Speed"].." = "
						return RSD:RecentLevelSpeed() == L["[No Data]"] and a.."|cffF6ADC6"..L["[No Data]"].."|r" or a.."|cffB6CA00"..format("%.2f", RSD:RecentLevelSpeed()/3600).."|r "..HOUR.."/"..LEVEL
					end,
				},
				LevelSpeed_Avg = {
					type = "description",
					order = 9,
					name = function()
						local a = " "..L["Average"].." "..L["Level Speed"].." = "
						return player.level > 1 and a.."|cff71D5FF"..format("%.2f", ((TPM_totalTime+RSD:AddedTime())/3600)/(player.level-1)).."|r "..HOUR.."/"..LEVEL.."\n" or a.."|cffF6ADC6"..L["[No Data]"].."|r\n"
					end,
				},
				Activity = {
					type = "description",
					order = 10,
					name = function()
						local a = char.unixTimeList[player.level]
						local b = " "..L["Activity"].." = "
						return a and b.."|cffB6CA00"..format("%.0f%%", ((TPM_currentTime+RSD:AddedTime())/(time()-a))*100).."|r" or b.."|cffF6ADC6"..L["[No Data]"].."|r"
					end,
				},
				Activity_Avg = {
					type = "description",
					order = 11,
					name = function()
						local a = char.unixTimeList[1] or char.unixTimeList[2]
						local b = " "..L["Average"].." "..L["Activity"].." = "
						return a and b.."|cff71D5FF"..format("%.0f%%", ((TPM_totalTime+RSD:AddedTime())/(time()-a))*100) .."|r\n" or b.."|cffF6ADC6"..L["[No Data]"].."|r\n"
					end,
				},
				TimeAFK = {
					type = "description",
					order = 12,
					name = function() return " "..L["AFK Time"].." = |cffB6CA00"..RSD:TimetoString(stats.timeAFK).."|r" end,
				},
				TimeAFK_Avg = {
					type = "description",
					order = 13,
					name = function() return " "..L["Total AFK Time"].." = |cff71D5FF"..RSD:TimetoString(stats.totalAFK).."|r\n" end,
				},
				Quests = {
					type = "description",
					order = 14,
					name = function()
						local quests, daily = RSD:AchievementStatistics("quests")
						return " "..PLAYER_DIFFICULTY1.." "..QUESTS_LABEL.." = |cffADFF2F"..quests.."|r, "..DAILY.." "..QUESTS_LABEL.." = |cff6495ED"..daily.."|r"
					end,
				},
				Kills = {
					type = "description",
					order = 15,
					name = function() return " "..KILLS.." = |cffB6CA00"..stats.kills.."|r, "..L["Total Kills"].." = |cff71D5FF"..RSD:AchievementStatistics("kills").."|r" end,
				},
				Deaths = {
					type = "description",
					order = 16,
					name = function() return " "..DEATHS.." = |cffFF0000"..stats.deaths.."|r, "..L["Total Deaths"].." = |cffFF0000"..RSD:AchievementStatistics("deaths").."|r" end,
				},
				header = {
					type = "header",
					order = 17,
					name = "",
				},
				PrintLevelData = {
					type = "execute",
					order = 18,
					name = "|TInterface\\Icons\\INV_Misc_Note_01:16:16:1:-1"..iconCropped.."|t  |cffFFFFFFLevel Data|r",
					func = function()
						for i = 2, player.maxLevel do
							if char.levelTimeList[i] then
								print(LEVEL.." |cffF6ADC6"..i-1 .."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..RSD:TimetoString(char.levelTimeList[i], true).."|r   "..L["Total"]..": |cff71D5FF"..RSD:TimetoString(char.totalTimeList[i], true).."|r")
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 19, name = ""},
				ExportData = {
					type = "execute",
					order = 20,
					name = "|TInterface\\Icons\\Trade_Engineering:16:16:1:-1"..iconCropped.."|t  |cffFFFFFFExport|r",
					func = function() RSD:ExportData() end,
					disabled = "OptionsDisabled",
				},
				newline02 = {type = "description", order = 21, name = ""},
				PlaySound = {
					type = "execute",
					order = 22,
					desc = "|cffADFF2Fboosts e-peen|r",
					name = "|TSPELLS\\HOLIDAYS\\Heart:16:16:0:-1|t  |cffF6ADC6Play Sound|r", -- ...\Data\common.MPQ\SPELLS\HOLIDAYS\Heart.blp
					func = function()
						if time() > (cd.playSound or 0) then
							cd.playSound = time() + 3
							local descInterface = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Interface\\\\|r|cff71D5FF"
							local descSpell = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Spells\\\\|r|cff71D5FF"
							local descEnd = "|r|cffB6CA00.ogg\")|r\n"
							local a = random(10)

							if a <= 2 then PSF("Sound\\Interface\\LevelUp.ogg", "Master"); soundPath = descInterface.."LevelUp"..descEnd -- ...\Data\sound.MPQ\Sound\Interface\LevelUp.ogg -- Player Leveled Up
							elseif a == 3 or a == 4 then PSF("Sound\\Interface\\iQuestComplete.ogg", "Master"); soundPath = descInterface.."iQuestComplete"..descEnd -- ...\Data\sound.MPQ\Sound\Interface\iQuestComplete.ogg -- Quest Comepleted
							elseif a == 5 or a == 6 then PSF("Sound\\Spells\\AchievmentSound1.ogg", "Master"); soundPath = descSpell.."AchievmentSound1"..descEnd -- ...\Data\sound.MPQ\Sound\Spells\AchievmentSound1.ogg -- Achievement Gained
							elseif a == 7 or a == 8 then PSF("Sound\\Spells\\Resurrection.ogg", "Master"); soundPath = descSpell.."Resurrection"..descEnd -- ...\Data\sound.MPQ\Sound\Spells\Resurrection.ogg -- Resurrection
							elseif a == 9 then PSF("Sound\\Creature\\Paletress\\AC_Paletress_Death01.ogg", "Master"); soundPath = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Creature\\\\Paletress\\\\|r|cff71D5FFAC_Paletress_Death01"..descEnd -- lol
							elseif a == 10 then PSF("Sound\\Character\\BloodElf\\BloodElfFemaleFlirt02.ogg", "Master"); soundPath = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Character\\\\BloodElf\\\\|r|cff71D5FFBloodElfFemaleFlirt02"..descEnd
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				SoundPath = {
					type = "description",
					order = 23,
					name = function()
						return time() < (cd.playSound or 0) and soundPath or "\n"
					end,
				},
			},
		},
		RandomMessage = {
			type = "group",
			name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:0:5|t  Random Messages",
			handler = RSD,
			args = {
				input1 = {
					type = "input",
					order = 1,
					width = "full",
					name = "  Note: This part is kinda experimental, I'm a noob with frames / AceGUI ...",
					usage = legend,
					get = function(i) return profile.dingMessage[2] end,
					set = function(i, v) profile.dingMessage[2] = v
						if #strtrim(v) == 0 then profile.dingMessage[2] = defaults.profile.dingMessage[2] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description1 = {
					type = "description",
					order = 2,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[2], true) end,
				},
				input2 = {
					type = "input",
					order = 3,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[3] end,
					set = function(i, v) profile.dingMessage[3] = v
						if #strtrim(v) == 0 then profile.dingMessage[3] = defaults.profile.dingMessage[3] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description2 = {
					type = "description",
					order = 4,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[3], true) end,
				},
				input3 = {
					type = "input",
					order = 5,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[4] end,
					set = function(i, v) profile.dingMessage[4] = v
						if #strtrim(v) == 0 then profile.dingMessage[4] = defaults.profile.dingMessage[4] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description3 = {
					type = "description",
					order = 6,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[4], true) end,
				},
				input4 = {
					type = "input",
					order = 7,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[5] end,
					set = function(i, v) profile.dingMessage[5] = v
						if #strtrim(v) == 0 then profile.dingMessage[5] = defaults.profile.dingMessage[5] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description4 = {
					type = "description",
					order = 8,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[5], true) end,
				},
				input5 = {
					type = "input",
					order = 9,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[6] end,
					set = function(i, v) profile.dingMessage[6] = v
						if #strtrim(v) == 0 then profile.dingMessage[6] = defaults.profile.dingMessage[6] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description5 = {
					type = "description",
					order = 10,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[6], true) end,
				},
			},
		},
		RandomMessageGuild = {
			type = "group",
			name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:0:5|t  Random |cff40FF40"..GUILD.."|r Messages",
			handler = RSD,
			args = {
				input1 = {
					type = "input",
					order = 1,
					width = "full",
					name = " ",
					usage = legend2,
					get = function(i) return profile.guildMemberMsg[2] end,
					set = function(i, v) profile.guildMemberMsg[2] = v
						if #strtrim(v) == 0 then profile.guildMemberMsg[2] = defaults.profile.guildMemberMsg[2] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description1 = {
					type = "description",
					order = 2,
					name = function() return RSD:GetGuildExampleMsg(2) end,
				},
				input2 = {
					type = "input",
					order = 3,
					width = "full",
					name = " ",
					usage = legend2,
					get = function(i) return profile.guildMemberMsg[3] end,
					set = function(i, v) profile.guildMemberMsg[3] = v
						if #strtrim(v) == 0 then profile.guildMemberMsg[3] = defaults.profile.guildMemberMsg[3] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description2 = {
					type = "description",
					order = 4,
					name = function() return RSD:GetGuildExampleMsg(3) end,
				},
				input3 = {
					type = "input",
					order = 5,
					width = "full",
					name = " ",
					usage = legend2,
					get = function(i) return profile.guildMemberMsg[4] end,
					set = function(i, v) profile.guildMemberMsg[4] = v
						if #strtrim(v) == 0 then profile.guildMemberMsg[4] = defaults.profile.guildMemberMsg[4] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description3 = {
					type = "description",
					order = 6,
					name = function() return RSD:GetGuildExampleMsg(4) end,
				},
				input4 = {
					type = "input",
					order = 7,
					width = "full",
					name = " ",
					usage = legend2,
					get = function(i) return profile.guildMemberMsg[5] end,
					set = function(i, v) profile.guildMemberMsg[5] = v
						if #strtrim(v) == 0 then profile.guildMemberMsg[5] = defaults.profile.guildMemberMsg[5] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description4 = {
					type = "description",
					order = 8,
					name = function() return RSD:GetGuildExampleMsg(5) end,
				},
				input5 = {
					type = "input",
					order = 9,
					width = "full",
					name = " ",
					usage = legend2,
					get = function(i) return profile.guildMemberMsg[6] end,
					set = function(i, v) profile.guildMemberMsg[6] = v
						if #strtrim(v) == 0 then profile.guildMemberMsg[6] = defaults.profile.guildMemberMsg[6] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description5 = {
					type = "description",
					order = 10,
					name = function() return RSD:GetGuildExampleMsg(6) end,
				},
			},
		},
	},
}

	-----------------------------------
	---- 03  OnInitialize, OnEnable ---
	-----------------------------------

local titleName = "ReadySet|cffFFFFFFDing|r|TInterface\\AddOns\\ReadySetDing\\Images\\Windows7_Logo:16:16:3:0|t"

function RSD:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, true)

	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	self:RefreshConfig()

	self.db.global.version = 0.83
	self.db.global.fileType = "Beta"

	ACR:RegisterOptionsTable("ReadySetDing_Main", options.args.Main)
	ACR:RegisterOptionsTable("ReadySetDing_Advanced", options.args.Advanced)
	ACR:RegisterOptionsTable("ReadySetDing_GuildMemberDings", options.args.GuildMemberDings)
	ACR:RegisterOptionsTable("ReadySetDing_Screenshot", options.args.Screenshot)
	ACR:RegisterOptionsTable("ReadySetDing_Sound", options.args.Sound)
	ACR:RegisterOptionsTable("ReadySetDing_AutoGratz", options.args.AutoGratz)
	ACR:RegisterOptionsTable("ReadySetDing_Stats", options.args.Stats)
	ACR:RegisterOptionsTable("ReadySetDing_Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	ACR:RegisterOptionsTable("ReadySetDing_RandomMessage", options.args.RandomMessage)
	ACR:RegisterOptionsTable("ReadySetDing_RandomMessageGuild", options.args.RandomMessageGuild)

	optionsFrame.Main = ACD:AddToBlizOptions("ReadySetDing_Main", titleName)
	optionsFrame.Advanced = ACD:AddToBlizOptions("ReadySetDing_Advanced", "|TInterface\\Icons\\Trade_Engineering:16:16:1:0"..iconCropped.."|t  "..ADVANCED, titleName)
	optionsFrame.GuildMemberDings = ACD:AddToBlizOptions("ReadySetDing_GuildMemberDings", "|TInterface\\GuildFrame\\GuildLogo-NoLogo:16:16:1:0:64:64:14:51:14:51|t  "..L["Guild Dings"], titleName)
	optionsFrame.Screenshot = ACD:AddToBlizOptions("ReadySetDing_Screenshot", "|TInterface\\Icons\\inv_misc_spyglass_03:16:16:1:0"..iconCropped.."|t  "..L["Screenshot"], titleName)
	optionsFrame.Sound = ACD:AddToBlizOptions("ReadySetDing_Sound", "|TInterface\\Icons\\INV_Misc_Bell_01:16:16:1:0"..iconCropped.."|t  Sound", titleName)
	optionsFrame.AutoGratz = ACD:AddToBlizOptions("ReadySetDing_AutoGratz", "|TInterface\\Icons\\INV_Misc_Gift_05:16:16:1:0"..iconCropped.."|t  "..L["Auto Gratz"], titleName)
	optionsFrame.Stats = ACD:AddToBlizOptions("ReadySetDing_Stats", "|TInterface\\Icons\\INV_Misc_QuestionMark:16:16:1:0"..iconCropped.."|t  "..L["Stats"], titleName)
	optionsFrame.Profiles = ACD:AddToBlizOptions("ReadySetDing_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:16:16:1:0"..iconCropped.."|t  "..L["Profiles"], titleName)

	self:RegisterChatCommand("rsd", "SlashCommand")
	self:RegisterChatCommand("readyset", "SlashCommand")
	self:RegisterChatCommand("readysetding", "SlashCommand")

	-- Define AceDB saved variables if not yet defined
	char.levelTimeList = char.levelTimeList or {}
	char.totalTimeList = char.totalTimeList or {}
	char.experienceList = char.experienceList or {}
	char.unixTimeList = char.unixTimeList or {}
	char.dateStampList = char.dateStampList or {}
	char.activityList = char.activityList or {}
	char.levelSummary = char.levelSummary or {}
end

function RSD:OnEnable()
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")

	-- Party
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")

	-- Guild Member
	self:RegisterEvent("GUILD_ROSTER_UPDATE")

	-- (Real ID) Friend
	self:RegisterEvent("FRIENDLIST_UPDATE")

	-- Kills, Deaths
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	-- Auto Gratz
	self:RegisterEvent("CHAT_MSG_PARTY", "CHAT_MSG")
	self:RegisterEvent("CHAT_MSG_GUILD", "CHAT_MSG")
	self:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")

	-- AFK Time
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("PLAYER_LEAVING_WORLD")

	-- level 1 data
	if player.level == 1 then
		char.unixTimeList[1] = char.unixTimeList[1] or time()
		char.dateStampList[1] = char.dateStampList[1] or date("%Y.%m.%d %H:%M:%S")
	end

	------------------
	--- 06  Timers ---
	------------------
	-- this might not really be an efficient way
	-- but its the easiest/simplest though..

	-- wait (7 sec) for other AddOns first that want to request /played
	self:ScheduleTimer(function()
		if TPM_totalTime == 0 then
			RequestTimePlayed()
		end
	end, 7) -- 777!

	self:ScheduleRepeatingTimer(function()
		-- server side throttle on GuildRoster() is 10 seconds*
		GuildRoster()
	end, 11)

	self:ScheduleRepeatingTimer(function()
		FriendsFrame_Update()
		-- PARTY_MEMBERS_CHANGED doesn't seem to fire on party members ding
		-- don't know why I registered for it anyway if I'm using a repeating timer lol
		self:PARTY_MEMBERS_CHANGED()
	end, 3)	
end

	------------------------------
	--- 04  Callback Functions ---
	------------------------------
	
function RSD:RefreshConfig()
	profile, realm, char = self.db.profile, self.db.realm, self.db.char
	stats = char.stats
end

-- refresh all menus
function RSD:NotifyChange()
	ACR:NotifyChange("ReadySetDing_Main")
	ACR:NotifyChange("ReadySetDing_Advanced")
	ACR:NotifyChange("ReadySetDing_GuildMemberDings")
	ACR:NotifyChange("ReadySetDing_Stats")
end

-- gray out options when AddOn disabled
function RSD:OptionsDisabled()
	return not self:IsEnabled()
end

function RSD:SlashCommand(input)

	if #strtrim(input) == 0 then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Main)
		-- automatically expand the InterfaceOptionsFrame options by simulating a mouseclick
		for i = 1, #InterfaceOptionsFrameAddOns.buttons do
			if _G["InterfaceOptionsFrameAddOnsButton"..i]:GetText() == titleName and optionsFrame.Main.collapsed then
				_G["InterfaceOptionsFrameAddOnsButton"..i.."Toggle"]:Click()
				break
			end
		end

	elseif input == "enable" or input == "on" or input == "1" then
		if not self:IsEnabled() then
			self:Print("|cffADFF2FEnabled|r")
			self:Enable()
		end
		self:NotifyChange()

	elseif input == "disable" or input == "off" or input == "0" then
		if self:IsEnabled() then
			self:Print("|cffFF2424Disabled|r")
			self:Disable()
		end
		self:NotifyChange()

	-- dunno if someone would actually, if ever, use these shortcuts ..
	elseif input == "stats" or input == "stat" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Stats)
	elseif input == "export" or input == "exp" or input == "xp" then
		self:ExportData(true)

	else
		print("/rsd |cffADFF2Fon|r: Enable AddOn\n/rsd |cffFF2424off|r: Disable AddOn\n/rsd |cffFFFF00stats|r: Open Stats\n/rsd |cff71D5FFexport|r: Export to |cffFFFF00"..SLASH_SAY2.."|r (|cffFF2424SPAM!|r)")
	end
end

function RSD:GuildEmblem()
	if GuildFrameTabardEmblem then
		-- creating new tables = bad, i think. it gets GC'ed right? dont know how to do it without the table
		char.guildTexCoord = {GuildFrameTabardEmblem:GetTexCoord()}
	end
	if IsInGuild() and char.guildTexCoord then
		-- http://www.wowpedia.org/API_Texture_SetTexCoord
		return "|TInterface\\GuildFrame\\GuildEmblemsLG_01:32:32:-5:1:32:32:"..(char.guildTexCoord[1]*32)..":"..(char.guildTexCoord[7]*32)..":"..(char.guildTexCoord[2]*32)..":"..(char.guildTexCoord[8]*32).."|t"
	else
		return "|TInterface\\GuildFrame\\GuildLogo-NoLogo:32:32:-5:1|t"
	end
end

function RSD:TimetoString(value, fullString)
	local seconds = mod(floor(value), 60)
	local minutes = mod(floor(value/60), 60)
	local hours = mod(floor(value/3600), 24)
	local days = floor(value/86400)

--	use a Frame object to get rid of the pipe characters (|)
--	of the "grammar" UI escape sequences Global Strings
--	so that they can be used in SendChatMessage()
	local f_seconds = bttn:GetText(bttn:SetFormattedText(D_SECONDS, seconds))
	local f_minutes = bttn:GetText(bttn:SetFormattedText(D_MINUTES, minutes))
	local f_hours = bttn:GetText(bttn:SetFormattedText(D_HOURS, hours))
	local f_days = bttn:GetText(bttn:SetFormattedText(D_DAYS, days))

	if value >= 0 and value < 60 then
		return f_seconds
	elseif value >= 60 and value < 3600 then
	--	need the .0 / fullstring for a more consistent level summary
		if seconds >= 6 or fullString then
			if profile.timeFormat == 1 then
				return f_minutes..", "..f_seconds
			else
				-- bit ugly
				return bttn:GetText(bttn:SetFormattedText(D_MINUTES2, tonumber(minutes.."."..format("%.0f",floor(seconds/6)))))
			end
		else
			return f_minutes
		end
	elseif value >= 3600 and value < 86400 then
		if minutes > 0 or fullString then
			return f_hours..", "..f_minutes
		else
			return f_hours
		end
	elseif value >= 86400 then
		if hours > 0 or fullString then
			return f_days..", "..f_hours
		else
			return f_days
		end
	else
		return "ERROR: "..value
	end
end

function RSD:AddedTime()
	return time() - lastPlayedRequest
end

function RSD:TimeDiff(example)
	local timeDiff = 0
	local color1A, color1B, escape
	if char.levelTimeList[player.level] then
		if example then
			timeDiff = char.levelTimeList[player.level] - (TPM_currentTime+self:AddedTime())
			color1A, color1B, escape = "|cffF6ADC6", "|cffADFF2F", "|r"
		else
			local a = char.levelTimeList[player.level-1]
			if a then
				timeDiff = a - char.levelTimeList[player.level]
			end
			color1A, color1B, escape = "", "", ""
		end
	end
	return timeDiff < 0 and self:TimetoString(-timeDiff).." "..color1A..L["slower"]..escape or timeDiff > 0 and self:TimetoString(timeDiff).." "..color1B..L["faster"]..escape or L["[No Data]"]
end

-- update [AFK]
local function TimeAFK()
	timeAFK2 = time()
	stats.timeAFK = stats.timeAFK + (timeAFK2-timeAFK1)
	stats.totalAFK = stats.totalAFK + (timeAFK2-timeAFK1)
end

function RSD:LevelSummary()
	local level = player.level
	if char.levelTimeList[level] and char.levelCounter then
		char.levelSummary[char.levelCounter] = " "..LEVEL.." |cffF6ADC6"..level-1 .."|r - |cff71D5FF"..level.."|r:  |cffB6CA00"..self:TimetoString(char.levelTimeList[level], true).."|r        "..L["Total"]..":  |cff71D5FF"..self:TimetoString(char.totalTimeList[level], true).."|r"
	end
	return strjoin("\n", unpack(char.levelSummary)) or "ERROR"
end

local function LevelLimit()
	return player.level == GetMaxPlayerLevel() and "[Max Level]" or player.level + 1
end

-- [SPEED]; look for a 3 or smaller level difference
function RSD:RecentLevelSpeed()
	local a = char.levelTimeList
	for i = 3, 1, -1 do
		if a[player.level-i] then
			return ((a[player.level-i] + (TPM_totalTime-char.totalTimeList[player.level-i])) + self:AddedTime()) / (i+1)
		end
	end
	return a[player.level] and (a[player.level] + TPM_currentTime + self:AddedTime()) or L["[No Data]"]
end

local function RandomAutoGratzMsg()
	return profile.autoGratzMsg[random(6)]
end

local function RandomAutoGratzDelay()
	return profile.autoGratzDelay == 0 and random(20, 70) / 10 or profile.autoGratzDelay
end

local RAID_CLASS_COLORS = RAID_CLASS_COLORS

local function GetClassColor(class)
	return format("%02X%02X%02X", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
end

function RSD:OutputFrame(msg, example)
	if profile.outputFrame == 1 then
		if example then msg = "UIErrorsFrame" end
		UIErrorsFrame:AddMessage(msg)
	elseif profile.outputFrame ==  2 then
		if example then msg = "RaidWarningFrame" end
		RaidNotice_AddMessage(RaidWarningFrame, msg, {r=1, g=1, b=1})
	elseif profile.outputFrame ==  3 then
		if example then msg = "RaidBossEmoteFrame" end
		RaidNotice_AddMessage(RaidBossEmoteFrame, msg, {r=1, g=1, b=1})
	else
		for i = 1, NUM_CHAT_WINDOWS do
			if example then msg = "ReadySetDing: |cff71D5FF"..i..". "..GetChatWindowInfo(i).."|r" end
			if i == profile.outputFrame-3 then
				_G["ChatFrame"..i]:AddMessage(msg)
			end
		end
	end
end

function RSD:AutoGratz(msgType, name)
	self:ScheduleTimer(function() SCM(gsub(RandomAutoGratzMsg(), "%[[Nn][Aa][Mm][Ee]%]", name), msgType) end, RandomAutoGratzDelay())
end

-- http://www.wowhead.com/achievements=2
-- GetStatistic(AchievementID) returns a string type, but it will be "coerced" to a number type, I guess
function RSD:AchievementStatistics(info)
	local questsTotal, questsDaily, totalKills, totalDeaths

	if info == "quests" then
		if GS(98) == "--" then questsTotal = 0 else questsTotal = GS(98) end -- 98 = Quests completed
		if GS(97) == "--" then questsDaily = 0 else questsDaily = GS(97) end -- 97 = Daily quests completed
		-- Quests Completed(Achievement) = Quests completed(Statistic) - Daily quests completed(Statistic); thank you aldon@wowhead
		return questsTotal - questsDaily, questsDaily
	elseif info == "kills" then
		if GS(1197) == "--" then totalKills = 0 else totalKills = GS(1197) end -- 1197 = Total kills
		return totalKills
	elseif info == "deaths" then
		if GS(60) == "--" then totalDeaths = 0 else totalDeaths = GS(60) end -- 60 = Total Deaths
		return totalDeaths
	end
end

-- export level data to print/say (without spamming the server)
function RSD:ExportData(exportSay)
	local export
--	maybe I should learn how to sing the alphabet song ..
	local a, b, c, d, e -- delay
	local k, l, m, n -- coloring for print
	local q, r, s, t, u -- showed data type

--	why is there a throttle here anyway ... button bashers? spammers? xD
--	at least this will make sure LoggingChat() will be correctly set to it's previous value
	if time() > (cd.export or 0) then
		cd.export = time() + 17

		if exportSay then
			a, b, c, d, e = 0, 4, 8, 12, 16
			k, l, m, n = "", "", "", ""
			export = SCM

			local isLogging = LoggingChat()
			LoggingChat(true)

			self:ScheduleTimer(function() LoggingChat(isLogging) if q or r or s or t or u then self:Print("Logged Data to |cff71D5FF..\\Logs\\WoWChatLog.txt|r") end end, 17)

		else
			a, b, c, d, e = 0, 0.5, 1, 1.5, 2.0
			k, l, m, n = "|cffF6ADC6", "|cffB6CA00", "|cff71D5FF", "|r"
			export = print
		end

		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if char.levelTimeList[i] then
					if not q then export("# "..L["Level Time"]); q = true end
					export(k..i-1 ..n.."-"..l..i..n..": "..m..char.levelTimeList[i]..n)
				end
			end
		end, a)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if char.totalTimeList[i] then
					if not r then export("# "..L["Total Time"]); r = true end
					export(k.. 1 ..n.."-"..l..i..n..": "..m..char.totalTimeList[i]..n)
				end
			end
		end, b)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if char.experienceList[i] then
					if not s then export("# "..XP.."/"..HOUR); s = true end
					export(k..i-1 ..n.."-"..l..i..n..": "..m..char.experienceList[i]..n)
				end
			end
		end, c)
		self:ScheduleTimer(function()
			for i = 1, player.maxLevel do
				if char.dateStampList[i] then
					if not t then export("# Timestamp"); t = true end
					export(l..i..n..": "..m..char.dateStampList[i]..n)
				end
			end
		end, d)
		self:ScheduleTimer(function()
			for i = 1, player.maxLevel do
				if char.unixTimeList[i] then
					if not u then export("# Unix Timestamp"); u = true end
					export(l..i..n..": "..m..char.unixTimeList[i]..n)
				end
			end
		end, e)
	end
end

function RSD:GetGuildExampleMsg(index)
	--	GetNumGuildMembers returns 0 early in the game
	if IsInGuild() and GetNumGuildMembers() > 0 then
		local name, rank, _, level, class, zone, _, _, _, _, classFileName = GetGuildRosterInfo(random((GetNumGuildMembers())))
		if level == 85 then
			-- wow .. someone dinged level 86 :)
			level = 84
		end
		return "   "..RSD:ReplaceTextG(profile.guildMemberMsg[index], true, name, level+1, class, rank, zone, " in "..RSD:TimetoString(random(600, 7200)), " ("..format("%.2f", random(10, 30)/10).." "..HOUR.."/"..LEVEL..")", classFileName)
	else
		return "   |cffF6ADC6"..L["[No Data]"].."|r"
	end
end

function RSD:ValidateMessage(msg)
--	my patterns. just. suck. ><
	local msg = gsub(self:ReplaceText(msg, true), "|r", "")
	msg = gsub(msg, "|cff......", "")
	msg = gsub(msg, "|T.-|t", "") -- this 1 completely removes the (raid target) texture ><

--	show an error if message length exceeds 127 or 255 chars
	local a = strlen(msg)
	if a > 127 and profile.BNetBroadcast then
		print("RSD: |cff71D5FFReal ID|r |cffFF0000Message > 127 chars|r|r ("..a..")")
	end
	if a > 255 then
		print("RSD: |cffFF0000Message > 255 chars|r ("..a..")")
	end
end

function RSD:ReplaceText(msg, isExample)
	local gsub = gsub

	-- sanity check, or gsub will choke on it
	if not msg then return "[ERROR] No Message" end

	-- ** massive great wall of gsubs instantly crits you for a ludicrous amount of antimatter dmg **
	-- ** your computer gets struck by a coronal loop .. unless you're happily reading this in the year 2014 .. **

	if isExample then
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..player.level.."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffF6ADC6"..LevelLimit().."|r")
		msg = gsub(msg, "%[[Rr][Ee][Mm]%]", "|cffF6ADC6"..player.maxLevel - (player.level+1).."|r")
		msg = gsub(msg, "%[[Mm][Aa][Xx]]", "|cffF6ADC6"..player.maxLevel.."|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..self:TimetoString(TPM_currentTime+self:AddedTime()).."|r")
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", "|cff71D5FF"..self:TimetoString(TPM_totalTime+self:AddedTime()).."|r")
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", "|cff71D5FF"..self:TimeDiff(true).."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", "|cff71D5FF"..self:TimetoString(stats.timeAFK).."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", "|cff71D5FF"..self:TimetoString(stats.totalAFK).."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", "|cff0070DD"..date("%m/%d/%y %H:%M").."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", "|cff0070DD"..date("%Y.%m.%d %H:%M").."|r")
		msg = gsub(msg, "%[[Xx][Pp]%]", "|cffB6CA00"..format("%0.f", UnitXP("player")/((TPM_currentTime+RSD:AddedTime())/3600)).."|r")
		if self:RecentLevelSpeed() == L["[No Data]"] then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffF6ADC6"..L["[No Data]"].."|r")
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..format("%.2f",self:RecentLevelSpeed()/3600).."|r")
		end
		if player.level > 1 then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffB6CA00"..format("%.2f",(TPM_totalTime+self:AddedTime())/(3600*(player.level-1))).."|r")
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffF6ADC6"..L["[No Data]"].."|r")
		end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", "|cffFF0000"..stats.kills.."|r")
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", "|cffFF0000"..self:AchievementStatistics("kills").."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", "|cffFF0000"..stats.deaths.."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", "|cffFF0000"..self:AchievementStatistics("deaths").."|r")
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", "|cff58ACFA"..self:AchievementStatistics("quests").."|r")
		if GetRealZoneText() then
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cff58ACFA"..GetRealZoneText().."|r") -- not sure if its too early or already avaiable at this point
		else
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6[No Zone Info]|r")
		end
		if IsInGuild() and GetGuildInfo("player") then
			msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffADFF2F"..GetGuildInfo("player").."|r")
		else
			msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffF6ADC6[No Guild]|r")
		end
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F"..player.name.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cffADFF2F"..player.class.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", "|cffADFF2F"..player.race.."|r")
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", "|cffADFF2F"..player.faction.."|r")
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", "|cffADFF2F"..player.realm.."|r")
		for i = 1, 8 do
			msg = gsub(msg, "%{[Rr][Tt]"..i.."%}", "|T"..RT..i..":12|t")
		end
		msg = gsub(msg, "%{[Xx]%}", "|T"..RT.."7:12|t")
		msg = gsub(msg, "%{[Ss][Tt][Aa][Rr]%}", "|T"..RT.."1:12|t")
		msg = gsub(msg, "%{[Cc][Ii][Rr][Cc][Ll][Ee]%}", "|T"..RT.."2:12|t")
		msg = gsub(msg, "%{[Dd][Ii][Aa][Mm][Oo][Nn][Dd]%}", "|T"..RT.."3:12|t")
		msg = gsub(msg, "%{[Tt][Rr][Ii][Aa][Nn][Gg][Ll][Ee]%}", "|T"..RT.."4:12|t")
		msg = gsub(msg, "%{[Mm][Oo][Oo][Nn]%}", "|T"..RT.."5:12|t")
		msg = gsub(msg, "%{[Ss][Qq][Uu][Aa][Rr][Ee]%}", "|T"..RT.."6:12|t")
		msg = gsub(msg, "%{[Cc][Rr][Oo][Ss][Ss]%}", "|T"..RT.."7:12|t")
		msg = gsub(msg, "%{[Ss][Kk][Uu][Ll][Ll]%}", "|T"..RT.."8:12|t")
	else
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", player.level-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", player.level)
		msg = gsub(msg, "%[[Rr][Ee][Mm]%]", player.maxLevel - player.level)
		msg = gsub(msg, "%[[Mm][Aa][Xx]]", player.maxLevel)
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", self:TimetoString(char.levelTimeList[player.level]))
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", self:TimetoString(char.totalTimeList[player.level]))
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", self:TimeDiff())
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", self:TimetoString(stats.timeAFK))
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", self:TimetoString(stats.totalAFK))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", date("%m/%d/%y %H:%M"))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", date("%Y.%m.%d %H:%M"))
		msg = gsub(msg, "%[[Xx][Pp]%]", char.experienceList[player.level])
		if self:RecentLevelSpeed() == L["[No Data]"] then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", L["[No Data]"])
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", format("%.2f",self:RecentLevelSpeed()/3600))
		end
		if player.level > 1 then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", format("%.2f",(TPM_totalTime+self:AddedTime())/(3600*(player.level-1))))
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", L["[No Data]"])
		end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", stats.kills)
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", self:AchievementStatistics("kills"))
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", stats.deaths)
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", self:AchievementStatistics("deaths"))
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", self:AchievementStatistics("quests"))
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", GetRealZoneText())
		msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", select(1, GetGuildInfo("player")) or "[No Guild]")
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", player.name)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", player.class)
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", player.race)
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", player.faction)
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", player.realm)
	end
	return msg
end

function RSD:ReplaceTextG(msg, isExample, name, level, class, rank, zone, time, levelSpeed, classColor)
	local gsub = gsub

	if not msg then return "[ERROR] No Message" end

	if isExample then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cff"..GetClassColor(classColor).."|Hplayer:"..name.."|h"..name.."|h|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..level-1 .."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffADFF2F"..level.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cff71D5FF"..class.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", "|cffADFF2F"..rank.."|r")
		if zone then -- guild member's zone sometimes is nil
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6"..zone.."|r")
		else
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "")
		end
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..time.."|r")
		msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..levelSpeed.."|r")
	else
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", name)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", level-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", level)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", class)
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", rank)
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", zone or "")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", time)
		msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", levelSpeed)
	end
	return msg
end

	-----------------------------
	--- 05  OnEvent Functions ---
	-----------------------------

function RSD:PLAYER_LEVEL_UP(event, level)
	-- update here, since UnitLevel("player") does not yet return the new value
	player.level = level
	playerDinged = true
	RequestTimePlayed() -- call TIME_PLAYED_MSG

	-- reset if leveled 16+ times
	if not char.levelCounter or char.levelCounter > 15 then
		char.levelCounter = 0
	end
	char.levelCounter = char.levelCounter + 1
end

function RSD:TIME_PLAYED_MSG(event, ...)
--	these variables should be file-local scope -> vararg
	TPM_totalTime, TPM_currentTime = ...
	lastPlayedRequest = time()

	if playerDinged then
		playerDinged = false

		local a = char.totalTimeList[player.level-1]
		if a then
			-- TotalTime @ Ding - TotalTime @ previous Ding
			levelTime = TPM_totalTime - a
		else
			-- if no data for previous level, fall back to less accurate data
			-- Last undinged LevelTime + (dinged TotalTime - last undinged TotalTime)
			levelTime = TPM_currentTime2 + (TPM_totalTime-TPM_totalTime2)
		end

		-- save player data to arrays
		local level = player.level
		char.levelTimeList[level] = levelTime
		char.totalTimeList[level] = TPM_totalTime
		char.experienceList[level] = tonumber(format("%0.f", player.XPMax/(levelTime/3600)))
		char.unixTimeList[level] = time()
		char.dateStampList[level] = date("%Y.%m.%d %H:%M:%S")
		if char.unixTimeList[level-1] then
			char.activityList[level] = tonumber(format("%.0f", (levelTime/(time()-char.unixTimeList[level-1]))*100))
		end

		-- play custom sound if the user supplied one, otherwise it will silently fail
		PlaySoundFile(profile.customSound, "Master")

		local text = self:ReplaceText(profile.dingMessage[profile.randomMessage and random(2, 6) or 1])
		local language
		if profile.Language == 2 then
			-- random language
			language = GetLanguageByIndex(random(GetNumLanguages()))
		elseif profile.Language > 2 then
			language = GetLanguageByIndex(profile.Language-2)
		end

		local instanceType = select(2, IsInInstance())
	--	Announce Ding Message
		if profile.partyAnnounce then
			-- announce to /say instead when soloing instance
			local msgType
			if instanceType == "none" or instanceType == "party" then
				msgType = GetNumPartyMembers() > 0 and "PARTY" or "SAY"
			elseif instanceType == "raid" then
				msgType = "RAID"
			elseif instanceType == "pvp" then
				msgType = "BATTLEGROUND"
			end
			self:ScheduleTimer(function() SCM(text, msgType, language) end, profile.announceDelay)
		else
			self:OutputFrame(text)
		end

	--	Zone Announce
		if profile.zoneAnnounce then
			local a = {GetChannelList()}
			for i = 1, 10 do
			--	the General channel could possibly have any channel number assigned 
				if a[i*2] == GENERAL then
					self:ScheduleTimer(function() SCM(text, "CHANNEL", nil, i*2-1) end, profile.announceDelay)
				end
			end
		end

	--	Guild Announce
		if profile.guildAnnounce and IsInGuild() then
			self:ScheduleTimer(function() SCM(text, "GUILD", language) end, profile.announceDelay)
		end
		
	--	Real ID Broadcast
		if profile.BNetBroadcast then
			-- save current Real ID Broadcast message
			self:ScheduleTimer(function()
				local broadcastMsg = select(3, BNGetInfo())
				BNSetCustomMessage(text)
				BNSetCustomMessage(broadcastMsg)
			end, profile.announceDelay)
		end

		if profile.dingEmote then
			DoEmote(EMOTE389_TOKEN, "none")
		end

	--	Screenshot
		if profile.Screenshot then
		--	Hide UI (+ optional delay) to show the LevelUp animation
			local timeHideUI = profile.screenshotDelay-1
			if timeHideUI < 0 then timeHideUI = 0 end -- change any negative value to zero
		--	get original alpha; for some reason its always a bit different than the set value e.g. 0.9 -> 0.988... 0.5 -> 0.498...
			local originalAlpha = UIParent:GetAlpha()
		--	got problems with timing hiding and showing UI again,
		--	so trying to Hide()/SetAlpha(0) 1 sec before screenshot
			if profile.screenshotHideUI then
				self:ScheduleTimer(function() UIParent:SetAlpha(0) end, timeHideUI)
			end
			self:ScheduleTimer(function() Screenshot() end, profile.screenshotDelay)
			if profile.screenshotHideUI then
				self:ScheduleTimer(function() UIParent:SetAlpha(originalAlpha) end, profile.screenshotDelay+1)
			end
		end

		stats.kills, stats.deaths, stats.timeAFK = 0, 0, 0
		-- update level summary
		self:LevelSummary()
	end

	-- update/prepare stuff for next levelup
	TPM_totalTime2, TPM_currentTime2 = TPM_totalTime, TPM_currentTime
	player.XPMax = UnitXPMax("player")
	self:NotifyChange()
end

local friendsLocal, friendsBnet = {}, {}

-- (Real ID) friends
function RSD:FRIENDLIST_UPDATE(event, ...)
	if profile.friendDings then
		for i = 1, select(2, GetNumFriends()) do
			local name, level, class = GetFriendInfo(i)
			if friendsLocal[name] and level > friendsLocal[name] then
				self:OutputFrame("|cff82C5FF|Hplayer:"..name.."|h["..name.."]|h|r dinged "..LEVEL.." |cffADFF2F"..level.."|r")
			end
			if name then
				friendsLocal[name] = level
			end
		end
	end
	if profile.RealID_Dings then
		for i = 1, select(2, BNGetNumFriends()) do
			local presenceID, firstname, surname = BNGetFriendInfo(i)
			for j = 1, BNGetNumFriendToons(i) do
				local _, name, _, realm, _, race, class, _, _, level = BNGetFriendToonInfo(i, j)
				-- stupid starcraft 2 :/
				-- and just why is level a string type ..
				level = tonumber(level)
				local fullName = firstname.." "..surname
				local playerLink = "|HBNplayer:"..fullName..":"..presenceID.."|h["..fullName.."] (|TInterface\\ChatFrame\\UI-ChatIcon-WOW:14:14:0:-1|t"..name..")|h"
				if friendsBnet[name] and level and friendsBnet[name] > 0 and level > friendsBnet[name] then
					self:OutputFrame("|TInterface\\FriendsFrame\\UI-Toast-ToastIcons.tga:16:16:0:0:128:64:2:29:34:61|t|cff82C5FF"..playerLink.."|r dinged "..LEVEL.." |cffADFF2F"..level.."|r")
				end
				friendsBnet[name] = level
			end
		end
	end
end

local party = {}

function RSD:PARTY_MEMBERS_CHANGED()
	if profile.partyDings then
		for i = 1, GetNumPartyMembers() do
			-- UnitName can sometimes return string "Unknown" instead of just a nil
			local guid, level = UnitGUID("party"..i), UnitLevel("party"..i)
			local name, realm = UnitName("party"..i)
			-- some sanity checks
			if guid and party[guid] and party[guid] > 0 and level > party[guid] then
				self:OutputFrame("|cff"..GetClassColor(select(2, UnitClass("party"..i))).."|Hplayer:"..UnitName("party"..i)..(realm and "-"..realm or "").."|h["..name.."]|h|r dinged "..LEVEL.." |cffADFF2F"..level.."|r")
			end
			party[guid] = level
		end
	end
end

-- this part is rather messy
function RSD:GUILD_ROSTER_UPDATE()
	if IsInGuild() and (profile.GuildMemberDings or profile.guildMemberAnnounce) then
		-- check all guild members (including offlines); imagine this for a guild with 1000 members ><
		-- this is to avoid conflicts with other addons that change SetGuildRosterShowOffline(), and for level change diffs
		for i = 1, GetNumGuildMembers() do
			local name, rank, _, level, class, zone, _, _, _, _, classFileName = GetGuildRosterInfo(i)

			-- sanity check: in rare cases GetGuildRosterInfo() returns only a nil
			-- although I kinda think that realm[nil] would evaluate to a nil anyway ..
			if name and realm[name] then
				-- save (last 3 levels) level speed to [0] key
				for j = 3, 1, -1 do
					-- ignore the [0] and [1] key values
					if realm[name][level-j] and level-j ~= 1 and level-j ~= 0 then
						realm[name][0] = (time()-realm[name][level-j][1]) / (3600*j)
						break
					else
						-- no up to date data (or not anymore)
						realm[name][0] = nil
					end
				end

				--	level changed
				if level > realm[name][1] and name ~= player.name then
					-- online check (40 sec grace period for logging in)
					if time() > timeLogin + 40 then
						local levelTimeG, levelSpeedG = "", ""
					
						--	level time; ignore the [1] key value
						if level-1 ~= 1 and type(realm[name][level-1]) == "table" then
							levelTimeG = " in "..self:TimetoString(time() - realm[name][level-1][1])
						end

						--	level speed
						if realm[name][0] then
							levelSpeedG = " ("..format("%.2f", 1/realm[name][0]).." "..HOUR.."/"..LEVEL..")"
						end

						--	level filters
						if level >= profile.guildMemberLevelFilter and (not profile.guildMemberAchievementFilter or (profile.guildMemberAchievementFilter and mod(level, 10) > 0 and level ~= 85)) then
							if profile.guildMemberAnnounce then
								SCM(self:ReplaceTextG(profile.guildMemberMsg[profile.randomMessageGuild and random(2, 6) or 1], false, name, level, class, rank, zone, levelTimeG, levelSpeedG), "GUILD")
							end
							if profile.GuildMemberDings then
								self:OutputFrame(self:ReplaceTextG(profile.guildMemberMsg[1], true, name, level, class, rank, zone, levelTimeG, levelSpeedG, classFileName))
							end
						end
						--	save time & date of levelup
						realm[name][level] = {}
						realm[name][level][1] = time()
						realm[name][level][2] = date("%Y.%m.%d %H:%M:%S")
					else
						--	level changed while user was offline
						realm[name][level] = false -- don't got time & date
						if profile.GuildMemberDings then
							if not showedDiffs and char.lastCheck then
								showedDiffs = true
								print("RSD: |cffF6ADC6["..char.lastCheck.."]|r - |cffADFF2F["..date("%Y.%m.%d %H:%M").."]|r")
							end
							print("|cff"..GetClassColor(classFileName).."|Hplayer:"..name.."|h["..name.."]|h|r "..LEVEL.." |cffF6ADC6"..realm[name][1].."|r - |cffADFF2F"..level.."|r (+|cff71D5FF"..level-realm[name][1].."|r)")
						end
					end
				end
			end
			-- define guildmember / update level to [1] key
			realm[name] = realm[name] or {}
			realm[name][1] = level
		end
	end
end

-- Auto Gratz
function RSD:CHAT_MSG(event, msg, name)
	local throttle, msgType

	if event == "CHAT_MSG_PARTY" then
		throttle, msgType = cd.autoGratzParty, "PARTY"
	elseif event == "CHAT_MSG_GUILD" then
		throttle, msgType = cd.autoGratzGuild, "GUILD"
	end

	if profile.AutoGratz and name ~= player.name and strfind(msg, "[Dd][Ii][Nn][Gg]") and strlen(msg) <= 10 and time() > (throttle or 0) then
		cd.autoGratzParty = time() + profile.autoGratzCooldown		
		self:AutoGratz(msgType, name)
	end
end

function RSD:CHAT_MSG_GUILD_ACHIEVEMENT(event, msg, name)
	if profile.AutoGratz and name ~= player.name and ((not profile.gratzAllAchievements and strfind(msg, LEVEL)) or profile.gratzAllAchievements) and time() > (cd.autoGratzGuild or 0) then
		cd.autoGratzGuild = time() + profile.autoGratzCooldown
		self:AutoGratz("GUILD", name)
	end
end

local MARKED_AFK_MESSAGE = gsub(MARKED_AFK_MESSAGE, "%%s", ".+")

function RSD:CHAT_MSG_SYSTEM(event, msg)

	if msg == MARKED_AFK or strfind(msg, MARKED_AFK_MESSAGE) then
		timeAFK1 = time()
	elseif msg == CLEARED_AFK and timeAFK1 then
		TimeAFK()
	end
end

-- update [AFK]
function RSD:PLAYER_LEAVING_WORLD()
	if UnitIsAFK("player") and timeAFK1 then
		TimeAFK()
	end
	-- time/date at logout for showing levelDiffs
	char.lastCheck = date("%Y.%m.%d %H:%M")
end

local toc42 = select(4, GetBuildInfo()) >= 40200

function RSD:COMBAT_LOG_EVENT_UNFILTERED(event, ...)

	-- assigning all parameters for clarity
	local timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags
	local spellID, spellName, spellSchool
	local SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, SuffixParam5, SuffixParam6, SuffixParam7, SuffixParam8, SuffixParam9

	-- patch 4.2.0 forwards compatible fix
	local suffixPos
	if toc42 then
		timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
		suffixPos = 12
	else
		timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = ...
		suffixPos = 10
	end

	local prefix = strsub(subevent, 1, 5)
	if prefix == "SWING" then
		SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, SuffixParam5, SuffixParam6, SuffixParam7, SuffixParam8, SuffixParam9 = select(suffixPos, ...)
	elseif prefix == "SPELL" or prefix == "RANGE" or prefix == "DAMAG" then
		spellID, spellName, spellSchool, SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, SuffixParam5, SuffixParam6, SuffixParam7, SuffixParam8, SuffixParam9 = select(suffixPos, ...)
	end

	-- [DEATHS]
	if subevent == "UNIT_DIED" and destName == player.name then
		stats.deaths = stats.deaths + 1
	end

	-- [KILLS]
	if sourceName == player.name then
		if strfind(subevent, "DAMAGE") and subevent ~= "ENVIRONMENTAL_DAMAGE" and subevent ~= "DAMAGE_SHIELD_MISSED" and SuffixParam2 > 0 and time() > (cd.PlayerKill or 0) then
			cd.PlayerKill = time() + 1
			stats.kills = stats.kills + 1
		end
	end

end